/*
 measure speed of memory (best and worst case)
 Version-20070427  4 x86-instructions per loop (gcc-4.1.1 -O2)
                   5 opteron-Instr. per loop (gcc-4.1.0 -O2)
                   4 sparcv9-Instr. per loop (gcc-4.1.1 -O2)
                  32 alpha-Instr. per loop (cxx-6.5 -fast)
  .L15: xorl    aa(,%edx,4), %edi    ; gcc-x86-p4
        addl    %ebx, %edx
        subl    $1, %eax
        jne     .L15
  .L16: ldx     [%g3], %g1           ; gcc-sparcv9
        add     %g2, -1, %g2
        xor     %l0, %g1, %l0
        brnz,pt %g2, .L16   
  .L900000128:                       ; CC-5.3-sparcv9
      add     %o1,%i3,%o1
      xor     %l0,%o2,%l0
      add     %i2,%i4,%i2
      addcc   %o4,-1,%o4
      bne,a,pt        %xcc,.L900000128

 # maxspeed=(1.3GHz/(loop=5Instr)=260MHz)*(long=4)=1040MB/s
 System                 Array Rand MaxMB/s Err  # new 4x->4summed
 PM- 600MHz-1MB          16MB   27    818   20  143ns 32bit-gcc-4.1.2 2GB hdparm=385MB/s
 P4-2.6GHz/2-512kB       16MB   20   1316   26  190ns 32bit-gcc-4.1.1 hdparm=1181MB/s FSB=4*100MHz Mem=266MHz*8=2128MB/s CPU=13*100MHz (default=13*200MHz) L2=512k=2^19 070427
 SunFire-880             32MB   23    220    6  346ns 64bit-gcc-4.1.1 USparcIII 750MHz
 SunFire-880             32MB   23    232    7  333ns 64bit-CC-5.3-fast-xarch=v9
 SunFire-V490            32MB   92    798   19   84ns 64bit-gcc-4.1.1 USparcIV+ 10*150MHz L2=32MB 8-way
 DOpteron275-2.2GHz      32MB   89   2130   34   88ns 64bit-gcc-4.1.1 L2=1MB  hdparm-T=1945MB/s 2.6.18 2DualCore
 DOpteron275-2.2GHz  2x  32MB  177   4129   16   88ns 64bit-gcc-4.1.1 L2=1MB  hdparm-T=1945MB/s 2.6.18 2DualCore 4*44MB/s+2*85MB/s
 DOpteron275-2.2GHz  4x  32MB  340   7156   92   91ns 64bit-gcc-4.1.1 L2=1MB  hdparm-T=1945MB/s 2.6.18 2DualCore
 DOpteron275-2.2GHz  6x  32MB  346   7200   98  177ns 64bit-gcc-4.1.1 L2=1MB  hdparm-T=1945MB/s 2.6.18 2DualCore 4*44MB/s+2*85MB/s
 DOpteron275-2.2GHz  8x  32MB  332   7248   92  189ns 64bit-gcc-4.1.1 L2=1MB  hdparm-T=1945MB/s 2.6.18 2DualCore
 DOpteron885-2.6GHz      32MB   35    838   21  223ns 64bit-gcc-4.1.0 8user   hdparm-T=1660MB/s BW=6.4GB/s(1CPU)
 Xeon-2333Mz-4MB         32MB   76   2916  132  102ns 64bit-gcc-4.1.1-long thor model=15 stepping=4  i5000P (maxBW=21GB/s) 2Quad
 Xeon-2333Mz-4MB     4x  32MB  176   4800  120  176ns 64bit-gcc-4.1.1-long thor model=15 stepping=4  i5000P (maxBW=21GB/s) 2Quad
 Xeon-2333Mz-4MB     8x  32MB  160   5832  128  381ns 64bit-gcc-4.1.1-long thor model=15 stepping=4  i5000P (maxBW=21GB/s) 2Quad 
 alpha-gs160-731MHz      16MB   20    295   49  397ns 64bit-gcc-4.1.1-long
 alpha-gs160-731MHz      16MB   20    295   49  397ns 64bit-cxx-6.5-long
 alpha-gs1280            32MB   31    453   50      - 64bit-cxx-6.5-long   (32cpus_per_rad) 0user
 alpha-gs1280            32MB   46    644   22  170ns 64bit-cxx-6.5-long   (8cpus_per_rad) 8user
 alpha-gs1280            32MB   46    339  170  170ns 64bit-gcc-4.1.1-long (8cpus_per_rad) 8user
 alpha-gs1280            32MB   77   1109    9  101ns 64bit-cxx-6.5-long   (1cpus_per_rad) 0user
 alpha-gs1280         32x32MB 2432  14400 1600      - 64bit-cxx-6.5-long   (32cpus_per_rad) 0user
 alpha-gs1280         32x32MB 2432  35520  640  102ns 64bit-cxx-6.5-long   (1cpus_per_rad) 0user
 alpha-es45-1250MHz      32MB   38    462   56  204ns 64bit-cxx-6.5-long 4user
 altix330-IA64-1.5GHz    32MB   22    309   12  349ns 64bit-gcc-4.1.1 Apr07
 altix330-IA64-1.5GHz 8x 32MB  168   2304   80  970ns 64bit-gcc-4.1.1 Apr07
 altix330-IA64-1.5GHz 15x32MB  660   9300  300  176ns 64bit-gcc-4.1.1 Apr07
 altix330-IA64-1.5GHz    32MB   54    670   14  143ns numactl --local-alloc
 altix330-IA64-1.5GHz 8x 32MB  392   4760  360  158ns numactl --local-alloc
 altix330-IA64-1.5GHz 15x32MB  735  10050  300  158ns numactl --local-alloc
#
 System                 Array Min MaxMB/s Err ln2MinStep # old
 PM- 600MHz-1MB 512MB    16MB   52    364   16    12   
 PM-1400MHz-1MB 512MB    16MB   50    364    8    12   
 Xeon-3GHz-1MB  2GB     256MB   39   1800   48    16   32bit-gcc-2.96  connect model=3 stepping=4  hdparm=800MB/s  busclock=200MHz
 Xeon-3GHz-2MB  2GB     256MB   44   2700   57    20   32bit-gcc-4.0.1 bb    model=4 stepping=3  hdparm=1472MB/s
 Xeon-3GHz-2MB 12GB     256MB   39   1422   31    20   64bit-gcc-4.1.1 morus model=4 stepping=10 memtest86+1.65=1257MB/s hdparm=1286MB/s
 Xeon-3GHz-2MB 12GB     512MB   38   1450   31    20   32bit-gcc-4.1.1-long morus model=4 stepping=10 memtest86+1.65=1257MB/s hdparm=1286MB/s
 Xeon-3GHz-2MB 12GB    8192MB   80   1170   23    19   64bit-gcc-4.1.1-long morus model=4 stepping=10 memtest86+1.65=1257MB/s hdparm=1286MB/s
 alpha-gs1280 128GB      32MB   36   1117   39    15   64bit-gcc-3.4.3-long (32cpus_per_rad) 2/82ns==25MB/s
 alpha-gs1280 128GB      32MB   41   2485   45    15   64bit-cxx-6.5-long   (32cpus_per_rad) (32x2.5GB/s=80GB/s local) remote.maxBW=6.3GB/s local.maxBW=12.3GB/s(767MHz*8channels*2Byte) 8B/(82ns..250ns)=>32..98MB/s
 alpha-gs1280 128GB      32MB   67   1117   39    16   64bit-gcc-3.4.3-long (1cpus_per_rad) 2/82ns==25MB/s
 alpha-gs1280 128GB      32MB   61   2485   47    16   64bit-cxx-6.5-long   (1cpus_per_rad) (32x2.5GB/s=80GB/s local)
 alpha-gs1280 128GB      16GB   24    572    7    23   64bit-cxx-6.5-long   (8cpus_per_rad)
 alpha-gs1280 128GB      16GB   29   1094   24    23   64bit-gcc-4.1.1-long (8cpus_per_rad)
 alpha-es45-1250MHz      16MB   87    818   20    11   cxx-int? 4/5CPU
 DOpteron275-2.2GHz-1MB  16MB   35   1500   34    13   64bit-gcc-3.4.6      hdparm-T=1900MB/s
 DOpteron885-2.6GHz-1MB 256MB   38   1120   39    15   64bit-gcc-4.0.3      hdparm-T=1660MB/s BW=6.4GB/s(1CPU)
 DOpteron885-2.6GHz-1MB 512MB   68   2300   82    15   64bit-gcc-4.0.3-long hdparm-T=1660MB/s
 DOpteron885-2.6GHz-1MB 512MB*4 46   2220   77    15   CPU3-6! 64bit-gcc-4.0.3-long hdparm-T=1660MB/s
 altix330-IA64-It2-1500MHz      11    270    9    10   64bit-gcc-3.3.3      hdparm-T=3600MB/s
 altix330-IA64-It2-1500MHz      25    441   12    12   numactl -c 7 -m 7
 altix330-IA64-It2-1500MHz      10    239    7     9   numactl -c 7 -m 3
 altix330-IA64-It2-1500MHz      10    233    7     9   2*ueber-kreuz (7,3)
 MinMax fuer 2 Jobs etc.
 cpu.model=generation stepping=version (same masque)
 ToDo: try __*_prefetch and improve loop (tune for generated asm-code)

*/
#define ALen (1024*1024*4)  // 2^22=4M*int=4M*4=16MB must be 2^n
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
long int aa[ALen];

int main(int argn, char *argv[]){
  time_t t1,t2,t=29;
  long int loops,a,i,j,r1,r2,r3,a2,k,l,x=0;
  if (argn>1) t=atoi(argv[1]); if (t<1) t=1;
  setvbuf(stdout, NULL, _IONBF, 0); /* dont buffer output */
  printf(" %d MB  int= %d  time_measure[s]= %d\n",
    (ALen>>20)*sizeof(long int),sizeof(long int)*8, (int)t);
  for (k=0;k<ALen;k++) { aa[k]=(k+1)&(ALen-1); }
  for (k=0;k<ALen;k++) { r1=random()&(ALen-1);
                         r2=aa[r1];r3=aa[k];
                         if (r3!=r1 && r2!=k) {aa[r1]=r3;aa[k]=r2;} }
  // measure random access = sizeof(long)/latency
  { // ln2 of look up steps
    loops=0;
    t1=time(NULL);
    for (i=1;i<100000;i*=2) {
      j=i;
      do { // repeat until some seconds are needed
         l=0; k=ALen;             // gcc-4.1 x86 2 instr.
         do {
           l=aa[l];               // gcc-4.1 x86 1 instr. 2Byte latency
           // __builtin_prefetch(aa+l);
         } while(--k);            // gcc-4.1 x86 2 instr.
      } while(--j);               // gcc-4.1 x86 2 instr.
      loops+=i;
      t2=time(NULL);
      // printf(" step=1<<%3d loops=%8d time/s=%3d\n", a,loops,(int)(t2-t1));
      if (t2-t1>t) break;
    }
    printf(" step=random  loops= %8d time/s= %4d %8d kB/s +/- %4d %dns\n",
       loops, (int)(t2-t1),
       (int)(ALen/1024*sizeof(long int)*loops/(t2-t1)  ),
       (int)(ALen/1024*sizeof(long int)*loops/(t2-t1-1)
            -ALen/1024*sizeof(long int)*loops/(t2-t1)  ),
            (int)((t2-t1)*1000000l/(loops*ALen/(1000)))  );
  }
  // measure memory throughput for different steps
  for (a=0;a<4;a++) { // ln2 of look up steps
    loops=0;
    a2=(1<<a); // step size
    t1=time(NULL);
    for (i=1;i<100000;i*=2) {
      j=i*a2;
      do { // repeat until some seconds are needed
         l=0; k=ALen>>a;          // gcc-4.1 x86 2 instr.
         do {
           x^=aa[l];              // gcc-4.1 x86 1 instr. 2Byte latency
           l=(l+a2);// &(ALen-1); // gcc-4.1 x86 1 instr.
           // __builtin_prefetch(aa+l); // gcc-4.1 x86-msse2 2 instr.
         } while(--k);            // gcc-4.1 x86 2 instr.
      } while(--j);               // gcc-4.1 x86 2 instr.
      loops+=i;
      t2=time(NULL);
      // printf(" step=1<<%3d loops=%8d time/s=%3d\n", a,loops,(int)(t2-t1));
      if (t2-t1>t) break;
    }
    printf(" step=1<< %3d loops= %8d time/s= %4d %8d kB/s +/- %4d %ld\n",
       a,loops,(int)(t2-t1),
       (int)(ALen/1024*sizeof(long int)*loops/(t2-t1)  ),
       (int)(ALen/1024*sizeof(long int)*loops/(t2-t1-1)
            -ALen/1024*sizeof(long int)*loops/(t2-t1)  ), l  );
  }
  return x+l;
}
